# Contributing to Puzzle Framework

Well... let us thanks you for your desire to contribute to our framework.

The contents of this document represent some guidelines for contributing to
the Puzzle Framework. These are mostly guidelines, not rules, so, use your 
best judgment and feel free to propose changes to this document in a pull request. 

This Contributing guide is inspired by the [Atom contributing guide](https://github.com/atom/atom/blob/master/CONTRIBUTING.md).

#### Table of contents
1. [Important Resources](#important-resources)

    1. [Documentation](#documentation)
    1. [Tests](#tests)
    1. [Samples](#samples)
    1. [Bin Tools](#bin-tools)
    1. [Tools Used](#tools-used)
   
1. [Environment Details](#environment-details)
   
1. [Contributing to the code](#contributing-to-the-code)

    1. [Reporting a bug](#reporting-a-bug)
    1. [Requesting Enhancements](#requesting-enhancements)
    1. [Submitting code](#submitting-code)
    1. [Your first contribution](#your-first-contribution)
    
1. [Style guide](#style-guide)

    1. [Git Commit Messages](#git-commit-messages)
    1. [Code guidelines](#code-guidelines)
    
## Important Resources

Before you start you need to know where you can find important resources inside our project.

### Documentation

The documentation of the framework is split into 2 major folders:
- `docs` - where all the developer written documentation is
- `gen-docs` - where the generated documentation is

The `docs` is structured by the different modules that are available
in the application.

The documentation files MUST be written in markdown.

The `gen-docs` contains code documentation generated by jsdoc. To generate a new version of this documentation please use the `npm run jsdoc` command. Documentation generated under this folder SHOULD NOT be committed. They will be updated by a repository maintainer.

### Tests

The tests written for the different parts of the framework are located in folder `tests`.

Unit tests are written using `mocha` and `chai`.

### Samples

Some sample files can be found in the `sample` folder.

### Bin tools

Under `bin` folder you can find some tools that might help you in your development.

### Tools used

The tools we use for working on this framework are:
- issue handling : https://gitlab.com/sprk.dev/index-framework/core/issues
- continuous integration: https://gitlab.com/sprk.dev/index-framework/core/pipelines


## Environment Details

To setup a development environment you will have to download the [sample project](https://gitlab.com/sprk.dev/puzzle-framework/sample)
and install all the dependencies it has. After that please use the `npm link` commands to link your
local instance of Puzzle Framework with the sample project.

Steps:
1. run `npm link` in the folder with the Puzzle Framework
2. run `npm link index-framework` in the folder with the sample project.

## Contributing to the code

You can contribute to the code in three ways: 
- by reporting a bug,
- by solving some of the bugs and issues that are reported,
- proposing some enhancements.

### Reporting a bug

Before reporting a bug please check the following list:
- Check the documentation, maybe the bug that you are trying to report is a "feature",
- Debug the code, maybe you can find the solution and submit it through a pull request,
- Check the issues list, maybe the bug was already reported - in this way you can add some extra information to the already existing problem,
- Check if the issue isn't triggered by a index (the packages used by the framework).

Now, that you've performed the steps above, please fill the template available [here](https://gitlab.com/sprk.dev/puzzle-framework/core/blob/master/sample/ISSUE_TEMPLATE.md).

When you will the template, try to explain the problem as clear as possible and as descriptive as possible. You can follow the guidelines below to help you in creating a good bug report:
- **Use a clear and descriptive title** for the issue to identify the problem.
- **Describe the exact steps which reproduce the problem** in as many details as possible.
- **Provide specific examples to demonstrate the steps.** Include links to files or GitHub projects, or copy/paste-able snippets, which you use in those examples. If you're providing snippets in the issue, use [Markdown code blocks](https://help.github.com/articles/markdown-basics/#multiple-lines).
- **Describe the behavior you observed after following the steps** and point out what exactly is the problem with that behavior.
- **Explain which behavior you expected to see instead and why.**
- **Include screenshots and animated GIFs** which show you following the described steps and clearly demonstrate the problem.
- **If the problem is related to performance or memory**, include a CPU profile capture with your report.
- **If the problem wasn't triggered by a specific action**, describe what you were doing before the problem happened and share more information using the guidelines below.

Also, a requirement for filling bugs is if can reliably reproduce the issue. If not, provide details about how often the problem happens and under which conditions it normally happens.

### Requesting Enhancements

Like in the case of reporting a bug, when you request or suggest an enhancement please do a check with the list below:

- Check the documentation, maybe the enhancement that you are trying to suggest was omitted because it was done by another part of the framework or a index (the packages used by the framework) deals with it,
- Debug the code, maybe you can find the enhancement already there,
- Check the issues list, maybe the enhancement was already requested/suggested by someone else - in this way you can add some extra information to the already existing suggestion.

Now, that you've performed the steps above, please fill the template available [here](https://gitlab.com/sprk.dev/puzzle-framework/core/blob/master/sample/ISSUE_TEMPLATE.md).

When you will the template, try to explain the enhancement as clear as possible and as descriptive as possible. You can follow the guidelines below to help you in creating a good enhancement request:

- **Use a clear and descriptive title** for the issue to identify the suggestion.
- **Provide a step-by-step description of the suggested enhancement** in as many details as possible.
- **Provide specific examples to demonstrate the steps.** Include copy/paste-able snippets, which you use in those examples. If you're providing snippets in the issue, use [Markdown code blocks](https://help.github.com/articles/markdown-basics/#multiple-lines).
- **Describe the current behavior and explain which behavior you expected to see instead** and why.
- **Include screenshots and animated GIFs** which show you following the described steps or point the part of the Puzzle Framework which the suggestion is related to.


### Submitting code

Unlike the bug reporting and enhancement request parts, the code submitting guide part is a little bit more restrictive. Same as above, we have a template that has to be filled (it can be found [here](https://gitlab.com/sprk.dev/puzzle-framework/core/blob/master/sample/PULL_REQUEST_TEMPLATE.md)).

The code has to be submitted through a pull request. For a pull request to be accepted it has to:

- contain the template above filled
- to not include the issue number in the PR title
- include screenshots and animated GIFs in your pull request whenever possible
- the code has to follow the [Javascript guidelines](#code-guidelines) 
- include tests for the written code
- document the code using the JSDoc specification
- end all files with a new line
- place requires in the following order, at the top of the file (for some well motivated cases this can be ignored):
    - built in Node modules (like `path`, `fs`, `http` etc.)
    - built in core Puzzle modules 
    - local modules (using relative paths)
    
### Your first contribution

Unsure what you can contribute on? Well you can:

- Update the documentation with examples, sample code, better formulated phrases etc.
- Update the sample project
- Look at the issues marked with the `begginer` tag
- Look at the issues marked with `help-wanted` tag

## Style guide

### Git Commit Messages

* Use the present tense ("Add feature" not "Added feature")
* Use the imperative mood ("Move cursor to..." not "Moves cursor to...")
* Limit the first line to 72 characters or less
* Reference issues and pull requests liberally after the first line
* When only changing documentation, include `[ci skip]` in the commit description
* Consider starting the commit message with an applicable emoji:
    * :art: `:art:` when improving the format/structure of the code
    * :racehorse: `:racehorse:` when improving performance
    * :non-potable_water: `:non-potable_water:` when plugging memory leaks
    * :memo: `:memo:` when writing docs
    * :penguin: `:penguin:` when fixing something on Linux
    * :apple: `:apple:` when fixing something on macOS
    * :checkered_flag: `:checkered_flag:` when fixing something on Windows
    * :bug: `:bug:` when fixing a bug
    * :fire: `:fire:` when removing code or files
    * :green_heart: `:green_heart:` when fixing the CI build
    * :white_check_mark: `:white_check_mark:` when adding tests
    * :lock: `:lock:` when dealing with security
    * :arrow_up: `:arrow_up:` when upgrading dependencies
    * :arrow_down: `:arrow_down:` when downgrading dependencies
    * :shirt: `:shirt:` when removing linter warnings

### Code guidelines

The Puzzle Framework follows the code guidelines defined by [Airbnb](https://github.com/airbnb/javascript) with some modifications:
  - module importing is done using require
  - allow dynamic requires
  
Other modfications can be seen in the `.eslintrc.json` file.


